'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IOrderDetails
		
	
		Property OrderID() As Int32
		Property ProductID() As Int32
		Property UnitPrice() As Decimal
		Property Quantity() As Int16
		Property Discount() As Single
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class OrderDetails 
		        Inherits PersistentObject
				Implements IOrderDetails, IComparable 
	
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>OrderID</c> attribute value.
		' </summary>
		' <value>The <c>OrderID</c> attribute value.</value>
        Public Property OrderID() As Int32 _
            Implements IOrderDetails.OrderID
			Get
                If (Not me("OrderID").Null) Then
                    Return CType(me("OrderID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("OrderID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ProductID</c> attribute value.
		' </summary>
		' <value>The <c>ProductID</c> attribute value.</value>
        Public Property ProductID() As Int32 _
            Implements IOrderDetails.ProductID
			Get
                If (Not me("ProductID").Null) Then
                    Return CType(me("ProductID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("ProductID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>UnitPrice</c> attribute value.
		' </summary>
		' <value>The <c>UnitPrice</c> attribute value.</value>
        Public Property UnitPrice() As Decimal _
            Implements IOrderDetails.UnitPrice
			Get
                If (Not me("UnitPrice").Null) Then
                    Return CType(me("UnitPrice").Value, Decimal)
                Else
                    Return New Decimal()
                End If
			End Get
			Set(ByVal Value As Decimal)
				me("UnitPrice").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Quantity</c> attribute value.
		' </summary>
		' <value>The <c>Quantity</c> attribute value.</value>
        Public Property Quantity() As Int16 _
            Implements IOrderDetails.Quantity
			Get
                If (Not me("Quantity").Null) Then
                    Return CType(me("Quantity").Value, Int16)
                Else
                    Return New Int16()
                End If
			End Get
			Set(ByVal Value As Int16)
				me("Quantity").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Discount</c> attribute value.
		' </summary>
		' <value>The <c>Discount</c> attribute value.</value>
        Public Property Discount() As Single _
            Implements IOrderDetails.Discount
			Get
                If (Not me("Discount").Null) Then
                    Return CType(me("Discount").Value, Single)
                Else
                    Return New Single()
                End If
			End Get
			Set(ByVal Value As Single)
				me("Discount").Value = Value
			End Set
		End Property
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

        Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try
                If TypeOf obj Is OrderDetails Then
                    Dim cmpOrderDetails As OrderDetails = CType(obj, OrderDetails)
                    If OrderID.CompareTo(cmpOrderDetails.OrderID) = 0 _
                     AndAlso ProductID.CompareTo(cmpOrderDetails.ProductID) = 0 Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If
            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of OrderDetails")
            End Try
            
        End Function
        Private Function SetupFields()

            AddField(New PersistentField("OrderID", False, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("ProductID", True, False, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("UnitPrice", True, False, TDevFramework.EDataType.eDecimal))
            AddField(New PersistentField("Quantity", True, False, TDevFramework.EDataType.eSmallInt))
            AddField(New PersistentField("Discount", True, False, TDevFramework.EDataType.eTinyInt))
        End Function

        Public Sub Copy(ByVal objInfo As OrderDetails)
            Me.OrderID = objInfo.OrderID
            Me.ProductID = objInfo.ProductID
            Me.UnitPrice = objInfo.UnitPrice
            Me.Quantity = objInfo.Quantity
            Me.Discount = objInfo.Discount
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
        End Sub
    End Class
End Namespace