'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================

Imports System
Imports System.Data
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IOrderDetailsCollection 
        Property item(ByVal index As Integer) As OrderDetails
        Sub Add(ByRef objValue As OrderDetails)
        Sub Remove(ByRef objValue As OrderDetails)
        Function Contains(ByRef objValue As OrderDetails) As Boolean
        Function IsContain(ByVal value As OrderDetails) As Int64
    End Interface
	

	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class OrderDetailsCollection
	    Inherits   Collection
	    Implements IOrderDetailsCollection 
        Public Sub New()
            '--
        End Sub

		' <summary>
		' Gets the <c>OrderDetails</c> object at the specified index.
		' </summary>
		' <value>The <c>OrderDetails</c> object.</value>
        Default Public Shadows Property item(ByVal index As Integer) As OrderDetails _
            Implements IOrderDetailsCollection.item
            Get
                Return CType(MyBase.Item(index), OrderDetails)
            End Get
			Set
				MyBase.Item(index) = value
			End Set
			
        End Property

        Public Overloads Sub Add(ByRef value As OrderDetails) _
            Implements IOrderDetailsCollection.Add

            MyBase.Add(value)
        End Sub

        Public Overloads Sub Remove(ByRef value As OrderDetails) _
            Implements IOrderDetailsCollection.Remove

            MyBase.Remove(value)
        End Sub

		' <summary>
		' If value is not of type object, this will return false.
		' </summary>
        Public Overloads Function Contains(ByRef value As OrderDetails) As Boolean _
            Implements IOrderDetailsCollection.Contains

            Return MyBase.Contains(value)
        End Function

        Public Function IsContain(ByVal value As OrderDetails) As Int64 _
        Implements IOrderDetailsCollection.IsContain
            Dim _orderDetails As OrderDetails
            Dim index As Int32 = 0

            For Each _orderDetails In List

                If _orderDetails.CompareTo(value) Then
                    Return index
                End If

                index = index + 1
            Next

            Return -1
        End Function

    End Class
End Namespace